"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RestPostRouter = void 0;
var BasicRouter_1 = require("../BasicRouter");
var headers_1 = require("../../utils/headers");
var RestPostRouter = (function (_super) {
    __extends(RestPostRouter, _super);
    function RestPostRouter(context, settings) {
        var _this = _super.call(this, context, settings) || this;
        _this.router = function (request, response) {
            var endpointUrl = _this.url.apiEndpoint(request);
            _this.logger.info('\nPOST: ' + endpointUrl);
            var reqBody = '';
            if (request.body) {
                reqBody = request.body;
                _this.processPostRequest(reqBody, request, response);
            }
            else {
                request.on('data', function (chunk) { return reqBody += chunk; });
                request.on('end', function () { return _this.processPostRequest(reqBody, request, response); });
            }
        };
        _this.processPostRequest = function (body, req, res) {
            var endpointUrl = _this.url.apiEndpoint(req);
            _this.logger.verbose('Request body:', body);
            var headers = headers_1.getHeaders(req.headers);
            if (_this.isDocumentEndpoint(endpointUrl)) {
                body = req.buffer;
                if (body) {
                    headers.set('Content-Length', "" + body.byteLength);
                }
            }
            if (typeof body === 'object' && Object.keys(body).length === 0) {
                if (endpointUrl.toLowerCase().indexOf('/_vti_bin/client.svc') !== -1 ||
                    endpointUrl.toLowerCase().indexOf('/_api/contextinfo') !== -1) {
                    body = '{}';
                }
                Object.keys(headers).forEach(function (prop) {
                    if (prop.toLowerCase() === 'content-length') {
                        headers.delete(prop);
                    }
                });
            }
            if (typeof body === 'object' && !_this.isDocumentEndpoint(endpointUrl)) {
                body = JSON.stringify(body);
            }
            _this.sp.fetch(endpointUrl, { method: 'POST', headers: headers, body: body })
                .then(_this.handlers.isOK)
                .then(_this.handlers.response(res))
                .catch(_this.handlers.error(res));
        };
        _this.isDocumentEndpoint = function (endpointUrl) {
            if (endpointUrl.toLowerCase().indexOf('/attachmentfiles/add') !== -1 ||
                endpointUrl.toLowerCase().indexOf('/files/add') !== -1 ||
                endpointUrl.toLowerCase().indexOf('/startupload') !== -1 ||
                endpointUrl.toLowerCase().indexOf('/continueupload') !== -1 ||
                endpointUrl.toLowerCase().indexOf('/finishupload') !== -1) {
                return true;
            }
            return false;
        };
        return _this;
    }
    return RestPostRouter;
}(BasicRouter_1.BasicRouter));
exports.RestPostRouter = RestPostRouter;
//# sourceMappingURL=restPost.js.map