"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadPageContext = exports.isLocalhost = void 0;
var misc_1 = require("./misc");
exports.isLocalhost = Boolean(window.location.hostname === 'localhost' ||
    window.location.hostname === '[::1]' ||
    window.location.hostname.match(/^127(?:\.(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){3}$/));
exports.loadPageContext = function (proxyEndpoint) {
    return new Promise(function (resolve) {
        if (typeof _spPageContextInfo !== 'undefined') {
            return resolve(_spPageContextInfo);
        }
        if (exports.isLocalhost) {
            var apiEndpoint_1 = proxyEndpoint || window.location.origin;
            var getWebInfo = function () {
                var restUrl = misc_1.trimMultiline("\n          " + apiEndpoint_1 + "/_api/web?\n            $select=Title,Language,ServerRelativeUrl,Url,\n              CurrentUser/Id,CurrentUser/LoginName,CurrentUser/Email,CurrentUser/Title,CurrentUser/IsSiteAdmin&\n            $expand=CurrentUser\n        ");
                return fetch(restUrl, {
                    method: 'GET',
                    headers: [
                        ['Accept', 'application/json;odata=verbose'],
                        ['X-ProxyStrict', 'false']
                    ]
                }).then(function (res) { return res.json(); });
            };
            var getSiteInfo = function () {
                var restUrl = apiEndpoint_1 + "/_api/site?$select=ServerRelativeUrl,Url";
                return fetch(restUrl, {
                    method: 'GET',
                    headers: [
                        ['Accept', 'application/json;odata=verbose'],
                        ['X-ProxyStrict', 'false']
                    ]
                }).then(function (res) { return res.json(); });
            };
            return Promise.all([getWebInfo(), getSiteInfo()])
                .then(function (_a) {
                var webInfo = _a[0].d, siteInfo = _a[1].d;
                var _spPageContextInfoFake = {
                    webTitle: webInfo.Title,
                    webAbsoluteUrl: apiEndpoint_1 + webInfo.ServerRelativeUrl,
                    webServerRelativeUrl: webInfo.ServerRelativeUrl,
                    currentLanguage: webInfo.Language,
                    siteAbsoluteUrl: apiEndpoint_1 + siteInfo.ServerRelativeUrl,
                    siteServerRelativeUrl: siteInfo.ServerRelativeUrl,
                    userId: webInfo.CurrentUser.Id,
                    userLoginName: webInfo.CurrentUser.LoginName,
                    userDisplayName: webInfo.CurrentUser.Title,
                    userEmail: webInfo.CurrentUser.Email,
                    isSiteAdmin: webInfo.CurrentUser.IsSiteAdmin,
                    __webAbsoluteUrl: webInfo.Url,
                    __siteAbsoluteUrl: siteInfo.Url,
                };
                window
                    ._spPageContextInfo = _spPageContextInfoFake;
                return resolve(_spPageContextInfoFake);
            });
        }
    });
};
//# sourceMappingURL=env.js.map