"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getHeaders = exports.copyHeaders = exports.getHeader = exports.mergeHeaders = void 0;
var node_fetch_1 = require("node-fetch");
exports.mergeHeaders = function () {
    var headers = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        headers[_i] = arguments[_i];
    }
    var res = new node_fetch_1.Headers();
    for (var _a = 0, headers_1 = headers; _a < headers_1.length; _a++) {
        var hh = headers_1[_a];
        if (hh) {
            hh.forEach(function (val, key) {
                if (val) {
                    res.set(key, val);
                }
                else {
                    res.delete(key);
                }
            });
        }
    }
    return res;
};
exports.getHeader = function (headers, header) {
    var res = null;
    Object.keys(headers).forEach(function (key) {
        if (key.toLowerCase() === header.toLowerCase()) {
            var val = headers[key];
            if (typeof val === 'string') {
                res = val;
            }
            else {
                res = val[0];
            }
        }
    });
    return res;
};
exports.copyHeaders = function (resp, headers, copy, ignore) {
    if (copy === void 0) { copy = []; }
    if (ignore === void 0) { ignore = []; }
    copy = copy.map(function (k) { return k.toLowerCase(); });
    ignore = ignore.map(function (k) { return k.toLowerCase(); });
    headers.forEach(function (val, key) {
        if (ignore.indexOf(key.toLowerCase()) === -1) {
            if (copy.length === 0 || copy.indexOf(key.toLowerCase()) !== -1) {
                resp.setHeader(key, val);
            }
        }
    });
};
exports.getHeaders = function (reqHeaders, ignoreHeaders) {
    if (ignoreHeaders === void 0) { ignoreHeaders = []; }
    var headers = new node_fetch_1.Headers();
    var ignoreDefaults = ['host', 'referer', 'origin'];
    ignoreHeaders = __spreadArrays(ignoreHeaders.map(function (h) { return h.toLowerCase(); }), ignoreDefaults);
    Object.keys(reqHeaders).forEach(function (prop) {
        if (ignoreHeaders.indexOf(prop.toLowerCase()) === -1) {
            headers.set(prop, exports.getHeader(reqHeaders, prop));
        }
    });
    return headers;
};
//# sourceMappingURL=headers.js.map